%the main class
Class-royal_member
Frame:royal_member
has_prop:fullname
has_prop:title
has_prop:birth_date

%subclass of royal_member for dead members
Subclass-dead_member
Frame:dead_member
is_A:royal_member
has_prop:death_date

%subclass of royal member for rulers
Subclass-monarch
Frame:monarch
is_A:royal_member
has_prop:rules_since
has_prop:rules_till

%subclass of monarch for dead monarch
Subclass-dead_monarch
Frame:dead_member
is_A:royal_member
has_prop:rules_till




% th eformat for the predicates and date
details(fullname(X), birth_date(Y1,M1,D1), death_date(Y2,M2,D2), rules_since(Y3,M3,D3), rules_till(Y4,M4,D4)).
distinction(fullname(X), title(Y)).
date(Year, Month, Day).



details(fullname(francisAlbertAugustusCharlesEmmanuel), birth_date(1819, 8, 26), death_date(1861, 12, 14),_,_).
distinction(fullname(francisAlbertAugustusCharlesEmmanuel), title('Prince Albert of Saxe-Coburg and Gotha')).
distinction(fullname(francisAlbertAugustusCharlesEmmanuel), title('Prince consort')).

details(fullname(alexandrinaVictoria), birth_date(1819, 5, 24), death_date(1901, 1, 22), rules_since(1837, 6, 20), rules_till(1901, 1, 22)).
distinction(fullname(alexandrinaVictoria), title('Queen Victoria of the United Kingdom of Great Britain and Ireland')).
distinction(fullname(alexandrinaVictoria), title('Empress of India')).

details(fullname(victoriaAdelaideMaryLouisa), birth_date(1840, 11, 21), death_date(1901, 8, 5),_,_).
distinction(fullname(victoriaAdelaideMaryLouisa), title('Victoria Pricess Royal')).
distinction(fullname(victoriaAdelaideMaryLouisa), title('Empress of Germany')).
distinction(fullname(victoriaAdelaideMaryLouisa), title('Queen of Prussia')).

details(fullname(albertEdward), birth_date(1841, 11, 9), death_date(1910, 5, 6), rules_since(1901, 1, 22), rules_till(1910, 5, 6)).
distinction(fullname(albertEdward), title('King Edward VII of the United Kingdom of Great Britain and Ireland ')).
distinction(fullname(albertEdward), title('Emperor of India')).
distinction(fullname(albertEdward), title('Duke of Cornwall')).
distinction(fullname(albertEdward), title('Duke of Rothesay')).
distinction(fullname(albertEdward), title('Prince of Saxe-Coburg and Gotha')).
distinction(fullname(albertEdward), title('Duke of Saxony')).
distinction(fullname(albertEdward), title('Prince of Wales')).
distinction(fullname(albertEdward), title('Earl of Chester')).
distinction(fullname(albertEdward), title('Earl of Dublin')).
distinction(fullname(albertEdward), title('Knight of the Garter')).
distinction(fullname(albertEdward), title('Knight of the Thistle')).



details(fullname(alexandraCarolineMarieCharlotteLouiseJulia), birth_date(1844, 12, 1), death_date(1925, 11, 20),_,_).
distinction(fullname(alexandraCarolineMarieCharlotteLouiseJulia), title('Princess Alexandra of Schleswig-Holstein-Sonderburg-Glücksburg')).
distinction(fullname(alexandraCarolineMarieCharlotteLouiseJulia), title('Princess Alexandra of Denmark')).
distinction(fullname(alexandraCarolineMarieCharlotteLouiseJulia), title('Princess Alexandra of Wales')).
distinction(fullname(alexandraCarolineMarieCharlotteLouiseJulia), title('Queen consort of the United Kingdom and the British Dominions')).
distinction(fullname(alexandraCarolineMarieCharlotteLouiseJulia), title('Empress consort of India')).
distinction(fullname(alexandraCarolineMarieCharlotteLouiseJulia), title('Queen Alexandra')).

details(fullname(aliceMaudMary), birth_date(1843, 4, 25), death_date(1878, 12, 14),_,_).
distinction(fullname(aliceMaudMary), title(' Grand Duchess of Hesse and by Rhine')).
distinction(fullname(aliceMaudMary), title(' Princess Alice of the United Kingdom')).

details(fullname(alfredErnestAlbert), birth_date(1844, 8, 6), death_date(1900, 7, 30),_,_).
distinction(fullname(alfredErnestAlbert), title('Duke of Saxe-Coburg and Gotha')).
distinction(fullname(alfredErnestAlbert), title('Duke of Edinburgh')).

details(fullname(helenaAugustaVictoria), birth_date(1846, 5, 25), death_date(1923, 6, 9),_,_).
distinction(fullname(helenaAugustaVictoria), title('Princess Helena of the United Kingdom')).
distinction(fullname(helenaAugustaVictoria), title(' Helena, Princess Christian of Schleswig-Holstein')).

details(fullname(louisaCarolineAlberta), birth_date(1848, 3, 18), death_date(1939, 12, 3),_,_).
distinction(fullname(louisaCarolineAlberta), title('Princess Louise, Duchess of Argyll')).
distinction(fullname(louisaCarolineAlberta), title('Marchioness of Lorne')).

details(fullname(arthurWilliamPatrickAlbert), birth_date(1850, 5, 1), death_date(1942, 1, 16),_,_).
distinction(fullname(arthurWilliamPatrickAlbert), title('Prince Arthur, Duke of Connaught and Strathearn')).

details(fullname(leopoldGeorgeDuncanAlbert), birth_date(1853, 4, 7), death_date(1884, 3, 28),_,_).
distinction(fullname(leopoldGeorgeDuncanAlbert), title('Prince Leopold')).
distinction(fullname(leopoldGeorgeDuncanAlbert), title('Duke of Albany')).
distinction(fullname(leopoldGeorgeDuncanAlbert), title('Earl of Clarence')).
distinction(fullname(leopoldGeorgeDuncanAlbert), title('Baron Arklow')).

details(fullname(beatriceMaryVictoriaFeodore), birth_date(1857, 4, 14), death_date(1944, 10, 26),_,_).
distinction(fullname(beatriceMaryVictoriaFeodore), title('Princess Beatrice of the United Kingdom')).
distinction(fullname(beatriceMaryVictoriaFeodore), title('Princess of Battenberg')).

details(fullname(georgeFrederickErnestAlbert), birth_date(1865, 6, 3), death_date(1936, 1, 20), rules_since(1910, 5, 6), rules_till(1936, 1, 20)).
distinction(fullname(georgeFrederickErnestAlbert), title('King George V of the United Kingdom and the British Dominions')).
distinction(fullname(georgeFrederickErnestAlbert), title('Emperor of India')).
distinction(fullname(georgeFrederickErnestAlbert), title('Prince of Wales')).
distinction(fullname(georgeFrederickErnestAlbert), title(' Duke of Cornwall and York')).


details(fullname(victoriaMaryAugustaLouiseOlgaPaulineClaudineAgnes), birth_date(1867, 5, 26), death_date(1953, 3, 24),_,_).
distinction(fullname(victoriaMaryAugustaLouiseOlgaPaulineClaudineAgnes), title('Princess of Wales')).
distinction(fullname(victoriaMaryAugustaLouiseOlgaPaulineClaudineAgnes), title('Princess  Mary of Teck')).
distinction(fullname(victoriaMaryAugustaLouiseOlgaPaulineClaudineAgnes), title('Duchess of Cornwall and York')).
distinction(fullname(victoriaMaryAugustaLouiseOlgaPaulineClaudineAgnes), title('Queen Consort of the United Kingdom and the British Dominions')).
distinction(fullname(victoriaMaryAugustaLouiseOlgaPaulineClaudineAgnes), title('Empress consort of India')).

details(fullname(albertVictorChristianEdward), birth_date(1864, 1, 8), death_date(1892, 1, 14),_,_).
distinction(fullname(albertVictorChristianEdward), title('Prince Albert Victor')).
distinction(fullname(albertVictorChristianEdward), title('Duke of Clarence and Avondale')).

details(fullname(louiseVictoriaAlexandraDagmar), birth_date(1867, 2, 20), death_date(1931, 1, 4),_,_).
distinction(fullname(louiseVictoriaAlexandraDagmar), title('Louise, Princess Royal')).
distinction(fullname(louiseVictoriaAlexandraDagmar), title('Princess Louise of Wales')).
distinction(fullname(louiseVictoriaAlexandraDagmar), title('Duchess of Fife')).

details(fullname(victoriaAlexandraOlgaMary), birth_date(1868, 7, 6), death_date(1935, 12, 3),_,_).
distinction(fullname(victoriaAlexandraOlgaMary), title('Princess Victoria of the United Kingdom')).
distinction(fullname(victoriaAlexandraOlgaMary), title('Princess Victoria of Wales')).

details(fullname(maudCharlotteMaryVictoria), birth_date(1869, 11, 26), death_date(1938, 11, 20),_,_).
distinction(fullname(maudCharlotteMaryVictoria), title('Princess Maud of Wales')).
distinction(fullname(maudCharlotteMaryVictoria), title('Queen of Norway')).
distinction(fullname(maudCharlotteMaryVictoria), title('Princess of Denmark')).

details(fullname(johnCharlesFrancis), birth_date(1905, 7, 12), death_date(1919, 1, 18),_,_).
distinction(fullname(johnCharlesFrancis), title('Prince John of the United Kingdom')).
distinction(fullname(johnCharlesFrancis), title('Prince John of Wales')).

details(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), birth_date(1894, 6, 23), death_date(1972, 5, 28), rules_since(1936, 1, 20), rules_till(1936, 12, 11)).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Prince Edward VIII')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Duke of Windsor')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('King Edward VIII of the United Kingdom and the Dominions of the British Empire')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Emperor of India')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Prince Edward VIII of York')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Prince Edward VIII of Cornwall and York')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Prince Edward VIII of Wales')).
distinction(fullname(edwardAlbertChristianGeorgeAndrewPatrickDavid), title('Duke of Cornwall')).


details(fullname(albertFrederickArthurGeorge), birth_date(1895, 12, 14), death_date(1952, 2, 6), rules_since(1936, 12, 11), rules_till(1952, 2, 6)).
distinction(fullname(albertFrederickArthurGeorge), title('King George VI of the United Kingdom and the Dominions of the British Commonwealth')).
distinction(fullname(albertFrederickArthurGeorge), title('Emperor of India')).
distinction(fullname(albertFrederickArthurGeorge), title('Head of the Commonwealth')).
distinction(fullname(albertFrederickArthurGeorge), title('Prince and Duke of York')).


details(fullname(elizabethAngelaMargueriteBowesLyon), birth_date(1900, 8, 4), death_date(2002, 3, 30),_,_).
distinction(fullname(elizabethAngelaMargueriteBowesLyon), title('Queen Elizabeth The Queen Mother')).
distinction(fullname(elizabethAngelaMargueriteBowesLyon), title('Queen of the United Kingdom and the Dominions')).
distinction(fullname(elizabethAngelaMargueriteBowesLyon), title('empress of India')).
distinction(fullname(elizabethAngelaMargueriteBowesLyon), title('Duchess of York')).
distinction(fullname(elizabethAngelaMargueriteBowesLyon), title('Queen consort')).
distinction(fullname(elizabethAngelaMargueriteBowesLyon), title('Lady Elizabeth Bowes-Lyon')).

details(fullname(victoriaAlexandraAliceMary), birth_date(1897, 4, 25), death_date(1965, 3, 28),_,_).
distinction(fullname(victoriaAlexandraAliceMary), title('Mary, Princess Royal and Countess of Harewood')).
distinction(fullname(victoriaAlexandraAliceMary), title('Princess Mary of Cornwall and York')).
distinction(fullname(victoriaAlexandraAliceMary), title('Princess Mary of Wales')).

details(fullname(henryWilliamFrederickAlbert), birth_date(1900, 3, 31), death_date(1974, 6, 10),_,_).
distinction(fullname(henryWilliamFrederickAlbert), title('Prince Henry, Duke of Gloucester')).
distinction(fullname(henryWilliamFrederickAlbert), title('Prince Henry of York')).
distinction(fullname(henryWilliamFrederickAlbert), title('Prince Henry of Cornwall and York')).
distinction(fullname(henryWilliamFrederickAlbert), title('Prince Henry of Wales')).

details(fullname(georgeEdwardAlexanderEdmund), birth_date(1902, 12, 20), death_date(1942, 8, 25),_,_).
distinction(fullname(georgeEdwardAlexanderEdmund), title('Prince George, Duke of Kent')).
distinction(fullname(georgeEdwardAlexanderEdmund), title('Prince George of Wales')).

details(fullname(alexanderJohn), birth_date(1871, 4, 6), death_date(1871, 4, 7),_,_).
distinction(fullname(alexanderJohn), title('Prince Alexander John of Wales')).

details(fullname(elizabethAlexandraMary), birth_date(1926, 4, 21),death_date(2020, 6, 1),rules_since(1952, 2, 6),_).
distinction(fullname(elizabethAlexandraMary), title('Queen Elizabeth II of the United Kingdom and the other Commonwealth realms')).
distinction(fullname(elizabethAlexandraMary), title('Princess Elizabeth of York')).
distinction(fullname(elizabethAlexandraMary), title('Princess Elizabeth, Duchess of Edinburgh')).
distinction(fullname(elizabethAlexandraMary), title('Head of the Commonwealth and Queen Regnant')).


details(fullname(margaretRose), birth_date(1930, 8, 21), death_date(2002, 2, 9),_,_).
distinction(fullname(margaretRose), title('Princess Margaret, Countess of Snowdon')).
distinction(fullname(margaretRose), title('Princess Margaret of York')).

details(fullname(philipMountbatten), birth_date(1921, 6, 10),death_date(2020, 6, 1),_,_).
distinction(fullname(philipMountbatten), title('Prince Philip, Duke of Edinburgh')).
distinction(fullname(philipMountbatten), title(' Prince Philip of Greece and Denmark')).
distinction(fullname(philipMountbatten), title(' Earl of Merioneth')).
distinction(fullname(philipMountbatten), title('Baron Greenwich')).
distinction(fullname(philipMountbatten), title('Knight of the Garter')).

details(fullname(charlesPhilipArthurGeorge), birth_date(1948, 11, 14),death_date(2020, 6, 1),_,_).
distinction(fullname(charlesPhilipArthurGeorge), title('Charles, Prince of Wales')).
distinction(fullname(charlesPhilipArthurGeorge), title('Duke of Cornwall')).
distinction(fullname(charlesPhilipArthurGeorge), title('Duke of Rothesay')).
distinction(fullname(charlesPhilipArthurGeorge), title('Charles, Prince of Wales')).

details(fullname(dianaFrancesSpencer), birth_date(1961, 7, 1), death_date(1997, 8, 31),_,_).
distinction(fullname(dianaFrancesSpencer), title('Diana, Princess of Wales')).
distinction(fullname(dianaFrancesSpencer), title('Lady Diana')).

details(fullname(camillaRosemaryShand), birth_date(1947, 7, 17),death_date(2020, 6, 1),_,_).
distinction(fullname(camillaRosemaryShand), title('Camilla, Duchess of Cornwall')).
distinction(fullname(camillaRosemaryShand), title('Duchess of Rothesay')).
distinction(fullname(camillaRosemaryShand), title('Countess of Chester')).

details(fullname(anneElizabethAliceLouise), birth_date(1950, 8, 15),death_date(2020, 6, 1),_,_).
distinction(fullname(anneElizabethAliceLouise), title('Anne, Princess Royal')).
distinction(fullname(anneElizabethAliceLouise), title('Princess Anne of Edinburgh')).

details(fullname(markAnthonyPeterPhillips), birth_date(1948, 9, 22),death_date(2020, 6, 1),_,_).
distinction(fullname(markAnthonyPeterPhillips), title('Captain Mark Phillips')).

details(fullname(timothyJamesHamiltonLaurence), birth_date(1955, 3, 1),death_date(2020, 6, 1),_,_).
distinction(fullname(timothyJamesHamiltonLaurence), title('Vice Admiral Sir Timothy Laurence')).

details(fullname(andrewAlbertChristianEdward), birth_date(1960, 2, 19),death_date(2020, 6, 1),_,_).
distinction(fullname(andrewAlbertChristianEdward), title('Prince Andrew, Duke of York')).

details(fullname(sarahMargaretFerguson), birth_date(1959, 10, 15),death_date(2020, 6, 1),_,_).
distinction(fullname(sarahMargaretFerguson), title('Sarah, Duchess of York')).

details(fullname(edwardAntonyRichardLouis), birth_date(1964, 3, 10),death_date(2020, 6, 1),_,_).
distinction(fullname(edwardAntonyRichardLouis), title('Prince Edward, Earl of Wessex  & Forfar')).

details(fullname(sophieHelenRhysJones), birth_date(1965, 1, 20),death_date(2020, 6, 1),_,_).
distinction(fullname(sophieHelenRhysJones), title('Sophie, Countess of Wessex')).
stinction(fullname(sophieHelenRhysJones), title('Countess of Forfar')).

details(fullname(williamArthurPhilipLouis), birth_date(1982, 6, 21),death_date(2020, 6, 1),_,_).
distinction(fullname(williamArthurPhilipLouis), title('Prince William, Duke of Cambridge')).
distinction(fullname(williamArthurPhilipLouis), title('Earl of Strathearn')).
distinction(fullname(williamArthurPhilipLouis), title('Baron Carrickfergus')).
distinction(fullname(williamArthurPhilipLouis), title('Prince William of Wales')).

details(fullname(henryCharlesAlbertDavid), birth_date(1984, 9, 15),death_date(2020, 6, 1),_,_).
distinction(fullname(henryCharlesAlbertDavid), title('Prince Harry, Duke of Sussex')).
distinction(fullname(henryCharlesAlbertDavid), title('Henry, Prince of Wales')).
distinction(fullname(henryCharlesAlbertDavid), title('The Earl of Dumbarton')).

details(fullname(catherineElizabethMiddleton), birth_date(1982, 1, 9),death_date(2020, 6, 1),_,_).
distinction(fullname(catherineElizabethMiddleton), title('Catherine, Duchess of Cambridge')).
distinction(fullname(catherineElizabethMiddleton), title('Princess of the United Kingdom')).
distinction(fullname(catherineElizabethMiddleton), title('Countess of Strathearn')).
distinction(fullname(catherineElizabethMiddleton), title('Lady Carrickfergus')).

details(fullname(peterMarkAndrewPhillips), birth_date(1977, 11, 15),death_date(2020, 6, 1),_,_).
distinction(fullname(peterMarkAndrewPhillips), title('Peter Phillips')).

details(fullname(zaraAnneElizabethTindall), birth_date(1981, 5, 15),death_date(2020, 6, 1),_,_).
distinction(fullname(zaraAnneElizabethTindall), title('Zara Tindall')).

details(fullname(autumnPatriciaPhillips), birth_date(1978, 5, 3),death_date(2020, 6, 1),_,_).
distinction(fullname(autumnPatriciaPhillips), title('Autumn Phillips')).

details(fullname(michaelJamesTindall), birth_date(1978, 10, 18),death_date(2020, 6, 1),_,_).
distinction(fullname(michaelJamesTindall), title('Mike Tindall')).

details(fullname(beatriceElizabethMary), birth_date(1988, 8, 8),death_date(2020, 6, 1),_,_).
distinction(fullname(beatriceElizabethMary), title('Princess Beatrice of York')).

details(fullname(eugenieVictoriaHelena), birth_date(1990, 3, 23),death_date(2020, 6, 1),_,_).
distinction(fullname(eugenieVictoriaHelena), title('Princess Eugenie of York')).

details(fullname(louiseAliceElizabethMaryMountbattenWindsor), birth_date(2003, 11, 8),death_date(2020, 6, 1),_,_).
distinction(fullname(louiseAliceElizabethMaryMountbattenWindsor), title('Lady Louise Windsor')).

details(fullname(jamesAlexanderPhilipTheoMountbattenWindsor), birth_date(2007, 12, 17),death_date(2020, 6, 1),_,_).
distinction(fullname(jamesAlexanderPhilipTheoMountbattenWindsor), title('James, Viscount Severn')).

details(fullname(georgeAlexanderLouis), birth_date(2013, 7, 22),death_date(2020, 6, 1),_,_).
distinction(fullname(georgeAlexanderLouis), title('Prince George of Cambridge')).

details(fullname(charlotteElizabethDiana), birth_date(2015, 5, 2),death_date(2020, 6, 1),_,_).
distinction(fullname(charlotteElizabethDiana), title('Princess Charlotte of Cambridge')).

details(fullname(louisArthurCharles), birth_date(2018, 4, 23),death_date(2020, 6, 1),_,_).
distinction(fullname(louisArthurCharles), title('Prince Louis of Cambridge')).

details(fullname(savannahAnneKathleenPhillips), birth_date(2010, 12, 29),death_date(2020, 6, 1),_,_).
distinction(fullname(savannahAnneKathleenPhillips), title('Savannah')).

details(fullname(islaElizabethPhillips), birth_date(2012, 3, 29),death_date(2020, 6, 1),_,_).
distinction(fullname(islaElizabethPhillips), title('Isla')).

details(fullname(miaGraceTindall), birth_date(2014, 1, 17),death_date(2020, 6, 1),_,_).
distinction(fullname(miaGraceTindall), title('Mia Grace')).

details(fullname(lenaElizabethTindall), birth_date(2018, 6, 18),death_date(2020, 6, 1),_,_).
distinction(fullname(lenaElizabethTindall), title('Lena Elizabeth')).

%rules
distinctions(X, Y) :- distinction(fullname(X), title(Y)).
date_of_birth(X, Y, M, D):- details(fullname(X), birth_date(Y,M,D),_,_,_).
date_of_death(X, Y, M, D):- details(fullname(X), _, death_date(Y,M,D),_,_).
ages(X, Birth, Death, Age) :- details(fullname(X), birth_date(Birth,_,_), death_date(Death,_,_),_,_), Age is Death-Birth.
age_when_ruler(X,Birth, Rule, Age) :- details(fullname(X), birth_date(Birth,_,_), _, rules_since(Rule,_,_),_), Age is Rule-Birth.
rulers_length(X,Birth,Death,Rules,Age,Length) :- details(fullname(X), birth_date(Birth,_,_), death_date(Death,_,_), rules_since(Rules,_,_),_), Age is Death-Birth, Length is Death-Rules.

